## $Id: container.py 7811 2012-03-08 19:00:51Z uli $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
Containers which contain document objects.
"""
import grok
from grok import index
from waeup.ikoba.documents.interfaces import IDocumentsContainer, IDocument
from waeup.ikoba.utils.helpers import attrs_to_fields

class DocumentsContainer(grok.Container):
    """This is a container for all kind of documents.
    """
    grok.implements(IDocumentsContainer)
    grok.provides(IDocumentsContainer)

    def __init__(self):
        super(DocumentsContainer, self).__init__()
        return

    def addDocument(self, document):
        if not IDocument.providedBy(document):
            raise TypeError(
                'DocumentsContainers contain only IDocument instances')
        self[document.id] = document
        return

DocumentsContainer = attrs_to_fields(DocumentsContainer)
